{% macro get_authors_json(
        entity_pk,
        author_m2m_tbl,
        author_m2m_key
    ) -%}
SELECT
    json_group_array(
        json_object(
            'display',
            ath.display,
            'alias',
            ath.alias,
            'first',
            ath.first,
            'last',
            ath.last,
            'org',
            ath.org,
            'org_url',
            ath.org_url
        )
    )
FROM
    authors ath
    JOIN {{ author_m2m_tbl }}
    x_tbl
    ON ath.email = x_tbl.author_id
WHERE
    x_tbl.{{ author_m2m_key }} = {{ entity_pk }}
{%- endmacro %}
/*
Each entity-ish table, e.g. Codifications, Statutes, Documents, has a corresponding primary key `pk`.
This is what the `entity_pk` refers to in the macro signature. Since each of these `pk` s is associated
with an author through the entity's `emails` column. The m2m lookup table is dependent
on the entity table, e.g.`CodificationAuthors` (`author_m2m_tbl`) is the lookup table for the
`Codififications` table, and such lookup table uses the `doc_id` as the relevant foreign key
which matches each author's email.
*/
