{% macro nulldefault(
        col,
        col_value
    ) -%}
    {#  when no value (None) appears for `caption` in Python, this part of the where clause will resolve to true #}
    (
        {{ default_to_null(
            col,
            col_value
        ) }}
        OR {{ test_value_is_null(col_value) }}
    )
{%- endmacro %}

{% macro default_to_null(
        col,
        col_value
    ) %}
    {# First part of null default func; assigns a default and makes a test if the column matches the value -#}
    {{ col }} = {{ col_value | default('NULL') }}
{%- endmacro %}

{% macro test_value_is_null(col_value) %}
    {# Second part of null default func; if the first part fails, in case of None, use the assigned null default -#}
    {{ col_value | default('NULL') }} IS NULL
{%- endmacro %}
