SELECT
    tbl.units -> t.path ->> '$.id' node_id,
    {# will output 1., 1.1., 1.1.1. -#}
    json_remove(
        tbl.units -> t.path,
        '$.units'
    ) node_data {# will remove the children node of these units #}
FROM
    {{ table }}
    tbl,
    json_tree(
        tbl.units,
        '$'
    ) t
WHERE
    tbl.pk = {{ table_pk }}
    {# e.g. mv-2022-ra-386-v1 -#}
    AND t.key = 'id'
    AND {{ unit_mp }} LIKE t.value || '%' {#e.g. mp = 1.1.1.2. -#}
    AND LENGTH(
        t.value
    ) < LENGTH(
        {{ unit_mp }}
    )
UNION
SELECT
    tbl2.units -> t2.path ->> '$.id' node_id,
    {# will output terminal 1.1.1.2 node -#}
    tbl2.units -> t2.path node_data
FROM
    {{ table }}
    tbl2,
    json_tree(
        tbl2.units,
        '$'
    ) t2
WHERE
    tbl2.pk = {{ table_pk }}
    AND t2.key = 'id'
    AND {{ unit_mp }} = t2.value {# e.g. 1.1.1.2. #}
ORDER BY
    node_id
