{% from 'statutes/_statute_title.sql' import get_statute_title %}
{% from 'statutes/_statute_date.sql' import get_statute_date %}
{% from 'codifications/_included_statutes.sql' import get_included_statutes %}
{% from '_utils/_json_array_authors.sql' import get_authors_json %}
{% macro get_codification_columns(
        tbl_alias,
        with_units = none
    ) -%}
    {% set serial_title = get_statute_title(
        'serial',
        '{}.statute_id'.format(tbl_alias)
    ) %}
    {% set official_title = get_statute_title(
        'official',
        '{}.statute_id'.format(tbl_alias)
    ) %}
    {% set statute_date = get_statute_date('{}.statute_id'.format(tbl_alias)) %}
    {% set included_statutes = get_included_statutes('{}.pk'.format(tbl_alias)) %}
    {# will collect all authors from emails and convert the result into a json array #}
    {% set authors_list = get_authors_json('{}.pk'.format(tbl_alias), 'CodificationAuthors', 'code_id') %}
    {# proper columns declaration #}
    {{ tbl_alias }}.pk,
    {{ tbl_alias }}.version,
    {{ tbl_alias }}.title,
    {{ tbl_alias }}.description,
    {{ tbl_alias }}.publication_date,
    {{ tbl_alias }}.statute_id,
    (
        {{ serial_title }}
    ) base_serial_title,
    (
        {{ official_title }}
    ) base_official_title,
    (
        {{ statute_date }}
    ) base_st_date,
    (
        {{ authors_list }}
    ) authors,
    (
        {{ included_statutes }}
    ) statutes_included

    {% if with_units %},
    {{ tbl_alias }}.units
{% endif %}
{%- endmacro %}
