{% from 'statutes/_statute_date.sql' import get_statute_date %}
{% from 'statutes/_statute_title.sql' import get_statute_title %}
{% macro get_included_statute_pks(code_pk) -%}
SELECT
    st.statute_id
FROM
    statutetitles st
WHERE
    category = 'serial'
    AND text IN (
        SELECT
            DISTINCT t.value
        FROM
            codifications code,
            json_tree(
                code.units,
                '$'
            ) t
        WHERE
            code.pk = {{ code_pk }}
            AND t.key = 'statute' {# history node contains a statute key #}
            AND t.value IS NOT NULL
    )
{%- endmacro %}

{% macro get_included_statutes(code_pk) -%}
SELECT
    json_group_array(
        json_object(
            'pk',
            stat.pk,
            'serial_title',
            (
                {{ get_statute_title(
                    'serial',
                    'stat.pk'
                ) }}
            ),
            'official_title',
            (
                {{ get_statute_title(
                    'official',
                    'stat.pk'
                ) }}
            ),
            'promulgation_date',
            ({{ get_statute_date('stat.pk') }}))
        ) statutes_included
        FROM
            statutes stat
        WHERE
            stat.pk IN ({{ get_included_statute_pks(code_pk) }})
{%- endmacro %}
