{% from 'statutes/_statute_title.sql' import get_statute_title %}
{% from 'statutes/_statute_date.sql' import get_statute_date %}
{% from '_utils/_json_array_authors.sql' import get_authors_json %}
{% macro get_codified_variants(selected_statute_id) -%}
    {% set serial_title = get_statute_title(
        'serial',
        '{}.statute_id'.format('C')
    ) %}
    {% set official_title = get_statute_title(
        'official',
        '{}.statute_id'.format('C')
    ) %}
    {% set statute_date = get_statute_date('{}.statute_id'.format('C')) %}
    {% set authors_list = get_authors_json('{}.pk'.format('C'), 'CodificationAuthors', 'code_id') %}
SELECT
    json_group_array(
        json_object(
            'pk',
            C.pk,
            'version',
            version,
            'title',
            C.title,
            'description',
            C.description,
            'publication_date',
            C.publication_date,
            'statute_id',
            C.statute_id,
            "base_serial_title",
            (
                {{ serial_title }}
            ),
            "base_official_title",
            (
                {{ official_title }}
            ),
            "base_st_date",
            (
                {{ statute_date }}
            ),
            "authors",
            (
                {{ authors_list }}
            )
        )
    ) codes
FROM
    codifications C
WHERE
    C.statute_id = {{ selected_statute_id }}
{%- endmacro %}
