{% from '_utils/_fts_mark_blurb.sql' import mark_blurb %}
{% macro get_cited_decisions_pk(case_pk) %}
SELECT
  cites0.pk
FROM
  citationsinopinions cites0
WHERE
  cites0.opinion_id = (
    SELECT
      op.pk
    FROM
      opinions op
    WHERE
      op.decision_id = {{ case_pk }}
      AND LOWER(category) = 'ponencia'
  )
  AND cites0.decision_id IS NOT NULL
{%- endmacro %}

{% macro get_cited_decisions(
    case_pk,
    query = none
  ) %}
  WITH decision_title(
    title,
    tags
  ) AS (
    SELECT
      title,
      tags
    FROM
      decisionindicators
    WHERE
      decision_id = cites.decision_id
  )
SELECT
  json_group_array(
    json_object(
      'pk',
      cites.decision_id,
      'doc_date',
      (
        SELECT
          date_prom
        FROM
          decisions
        WHERE
          pk = cites.decision_id
      ),
      'title',
      (
        SELECT
          title
        FROM
          decision_title
      ),
      'tags',
      (
        SELECT
          tags
        FROM
          decision_title
      ),
      'scra',
      cites.scra,
      'phil',
      cites.phil,
      'offg',
      cites.offg,
      'docket',
      cites.docket

      {% if query %},
      'snippet',
      (
        {{ mark_blurb(
          query,
          'cites.opinion_id',
          'opinions_fts',
          1
        ) }}
      )
      {% endif %}
    )
  )
FROM
  citationsinopinions cites
WHERE
  cites.pk IN ({{ get_cited_decisions_pk(case_pk) }})
{%- endmacro %}
