{% macro get_cited_statutes_pk(case_pk) %}
SELECT
  statop.pk
FROM
  statutesinopinions statop
WHERE
  statop.opinion_id = (
    SELECT
      op.pk
    FROM
      opinions op
    WHERE
      op.decision_id = {{ case_pk }}
      AND LOWER(category) = 'ponencia'
  )
  AND statop.statute_id IS NOT NULL
{%- endmacro %}

{% macro get_cited_statutes(case_pk) %}
SELECT
  json_group_array(
    json_object(
      'pk',
      stox1.statute_id,
      'serial_title',
      (
        SELECT
          text
        FROM
          statutetitles stx
        WHERE
          stx.category = 'serial'
          AND stx.statute_id = stox1.statute_id
      ),
      'official_title',
      (
        SELECT
          text
        FROM
          statutetitles stx
        WHERE
          stx.category = 'official'
          AND stx.statute_id = stox1.statute_id
      ),
      'promulgation_date',
      (
        SELECT
          DATE
        FROM
          statutes
        WHERE
          pk = stox1.statute_id
      )
    )
  )
FROM
  statutesinopinions stox1
WHERE
  stox1.pk IN ({{ get_cited_statutes_pk(case_pk) }})
{%- endmacro %}
