{% from 'decisions/_citation_data.sql' import get_citation_data %}
{% from 'decisions/_justice_data.sql' import get_justice_data %}
{% from 'decisions/_indicator_data.sql' import get_indicator_data %}
{% from 'decisions/_list_decisions.sql' import get_cited_decisions %}
{% from 'decisions/_list_statutes.sql' import get_cited_statutes %}
SELECT
    sc.pk pk,
    sc.source,
    sc.date_prom,
    ({{ get_citation_data('sc.pk') }}) citation_data,
    category,
    composition,
    ({{ get_indicator_data('sc.pk') }}) indicator_data,
    json_patch(({{ get_justice_data('sc.pk') }}), json_object('per_curiam', sc.per_curiam)) justice_data,
    (
        SELECT
            text
        FROM
            decisionvoting
        WHERE
            decision_id = sc.pk
    ) voting_line,
    ({{ get_cited_decisions('sc.pk') }}) decisions,
    ({{ get_cited_statutes('sc.pk') }}) statutes

    {% if show_body == true -%},(
        SELECT
            op.text
        FROM
            opinions op
        WHERE
            op.decision_id = sc.pk
            AND LOWER(
                op.category
            ) = "ponencia"
    ) ponencia
{% endif -%}
FROM
    decisions sc
WHERE
    sc.pk = {{ case_pk }}
