{% from 'decisions/_decision_date.sql' import get_decision_date %}
{% from 'decisions/_decision_title.sql' import get_decision_title %}
{% from '_utils/_fts_mark_blurb.sql' import mark_blurb %}
{% from 'decisions/fts/body_text/ids.sql' import get_body_text_ids %}
WITH rowid_data AS (
    {{ get_body_text_ids(
        q,
        start_row,
        end_row,
        sort_order
    ) }}
)
SELECT
    (
        SELECT
            max_count
        FROM
            rowid_data
    ) max_row,
    op.decision_id pk,
    ({{ get_decision_date('op.decision_id') }}) row_date,
    ({{ get_decision_title('op.decision_id') }}) title,
    (
        {{ mark_blurb(
            q,
            'op.rowid',
            'opinions_fts',
            1
        ) }}
    ) blurb
FROM
    opinions op
WHERE
    op.rowid IN (
        SELECT
            row_idx
        FROM
            rowid_data
    )
ORDER BY
    row_date {{ sort_order }}
