{% from 'decisions/_decision_date.sql' import get_decision_date %}
{% from 'decisions/_decision_title.sql' import get_decision_title %}
{% from '_utils/_fts_mark_blurb.sql' import mark_blurb %}
{% from 'decisions/fts/case_title/ids.sql' import get_case_title_ids %}
WITH rowid_data AS (
    {{ get_case_title_ids(
        q,
        start_row,
        end_row,
        sort_order
    ) }}
)
SELECT
    (
        SELECT
            max_count
        FROM
            rowid_data
    ) max_row,
    di.decision_id pk,
    ({{ get_decision_date('di.decision_id') }}) row_date,
    (
        {{ mark_blurb(
            q,
            'di.rowid',
            'decisionindicators_fts',
            0
        ) }}
        {# searches the title fts column: 0 #}
    ) title,
    iif(LENGTH(di.fallo), SUBSTR(di.fallo, 1, 100) || '...', NULL) blurb
FROM
    decisionindicators di
WHERE
    di.rowid IN (
        SELECT
            row_idx
        FROM
            rowid_data
    )
ORDER BY
    row_date {{ sort_order }}
