{% from 'decisions/_decision_date.sql' import get_decision_date %}
{% from '_utils/_fts_row_num.sql' import set_ordering %}
{% from '_utils/_fts_id_selector.sql' import select_ids %}
{% macro get_case_title_ids(
        q,
        start_row,
        end_row,
        sort_order
    ) -%}
    WITH rowids(
        row_idx,
        row_date,
        rn,
        max_count
    ) AS (
        SELECT
            di.rowid row_idx,
            ({{ get_decision_date('di.decision_id') }}) row_date,
            {{ set_ordering(get_decision_date('di.decision_id'), sort_order) }}
            rn,
            COUNT(*) over () max_count
        FROM
            decisionindicators di
            JOIN decisionindicators_fts
            ON di.rowid = decisionindicators_fts.rowid
        WHERE
            decisionindicators_fts match {{ q }}
        GROUP BY
            di.decision_id
    ) {{ select_ids(
        'rowids',
        start_row,
        end_row,
        sort_order
    ) }}
{%- endmacro %}
