{% from '_utils/_fts_mark_blurb.sql' import mark_blurb %}
{% from 'documents/fts/contents/ids.sql' import get_content_ids %}
{% from 'documents/_document_date.sql' import get_document_date %}
{% from 'documents/_document_title.sql' import get_document_title %}
WITH rowid_data AS (
    {{ get_content_ids(
        q,
        start_row,
        end_row,
        sort_order
    ) }}
)
SELECT
    (
        SELECT
            max_count
        FROM
            rowid_data
    ) max_row,
    doccont.pk pk,
    ({{ get_document_date('doccont.pk') }}) row_date,
    ({{ get_document_title('doccont.pk') }}) title,
    (
        {{ mark_blurb(
            q,
            'doccont.rowid',
            'documentcontent_fts',
            0
        ) }}
        {# make sure 0 is the proper fts column #}
    ) blurb
FROM
    documentcontent doccont
WHERE
    doccont.rowid IN (
        SELECT
            row_idx
        FROM
            rowid_data
    )
ORDER BY
    row_date {{ sort_order }}
