{% from 'documents/fts/document_titles/ids.sql' import get_title_ids %}
{% from '_utils/_fts_mark_blurb.sql' import mark_blurb %}
WITH rowid_data AS (
    {{ get_title_ids(
        q,
        start_row,
        end_row,
        sort_order
    ) }}
)
SELECT
    (
        SELECT
            max_count
        FROM
            rowid_data
    ) max_row,
    doc.pk pk,
    doc.publication_date row_date,
    doc.title title,
    (
        {{ mark_blurb(
            q,
            'doc.rowid',
            'documents_fts',
            0
        ) }}
        {# make sure 0 is the proper fts column #}
    ) blurb
FROM
    documents doc
WHERE
    doc.rowid IN (
        SELECT
            row_idx
        FROM
            rowid_data
    )
ORDER BY
    row_date {{ sort_order }}
