{% from '_utils/_null_default.sql' import test_value_is_null %}
{% macro fetch_unit_id(
        statute_id,
        locator,
        caption,
        content
    ) -%}
    WITH items_selected(node) AS (
        SELECT
            s.units ->> t0.path
        FROM
            statutes s,
            json_tree(
                s.units,
                '$'
            ) t0
        WHERE
            s.pk = {{ statute_id }}
            {# e.g. 'eo-292-july-25-1987'; mandatory #}
            AND t0.key = 'item'
            AND t0.value = {{ locator }}
            {#  e.g. 'Section 18'; mandatory #}
    )
SELECT
    node ->> 'id'
FROM
    items_selected
WHERE
    ({{ test_value_is_null(caption) }}
    {# when no value (None) appears for `caption` in Python, this part of the where clause will resolve to true #}
    OR node ->> '$.caption' = {{ caption | default('NULL') }}
    {# e.g. 'When Laws Take Effect.' #})
    AND ({{ test_value_is_null(content) }}
    {#  when no value (None) appears for `content` in Python, this part of the where clause will resolve to true #}
    OR node ->> '$.content' LIKE '%' || {{ content | default('NULL') }} || '%' {# e.g. 'The Supreme Court shall have the following powers')#})
{%- endmacro %}
