{% from 'statutes/_statute_date.sql' import get_statute_date %}
{% from 'statutes/_statute_title.sql' import get_statute_title %}
{% from '_utils/_fts_mark_blurb.sql' import mark_blurb %}
{% from 'statutes/fts/provisions/ids.sql' import get_provision_ids %}
{% from 'codifications/_json_array_codes.sql' import get_codified_variants %}
WITH rowid_data AS (
    {{ get_provision_ids(
        q,
        start_row,
        end_row,
        sort_order
    ) }}
)
SELECT
    (
        SELECT
            max_count
        FROM
            rowid_data
    ) max_row,
    stc.pk pk,
    ({{ get_statute_date('stc.pk') }}) row_date,
    ({{ get_statute_title('serial', 'stc.pk') }}) title,
    ({{ get_codified_variants('stc.pk') }}) codes,
    (
        {{ mark_blurb(
            q,
            'stc.rowid',
            'statutecontent_fts',
            0
        ) }}
        {# make sure 0 is the proper fts column #}
    ) blurb
FROM
    statutecontent stc
WHERE
    stc.rowid IN (
        SELECT
            row_idx
        FROM
            rowid_data
    )
ORDER BY
    row_date {{ sort_order }}
