{% from 'statutes/_statute_date.sql' import get_statute_date %}
{% from '_utils/_fts_row_num.sql' import set_ordering %}
{% from '_utils/_fts_id_selector.sql' import select_ids %}
{% macro get_provision_ids(
        q,
        start_row,
        end_row,
        sort_order
    ) -%}
    WITH rowids(
        row_idx,
        row_date,
        rn,
        max_count
    ) AS (
        SELECT
            sx.rowid,
            ({{ get_statute_date('sx.pk') }}),
            {{ set_ordering(get_statute_date('sx.pk'), sort_order) }}
            rn,
            COUNT(*) over ()
        FROM
            statutecontent sx
            JOIN statutecontent_fts
            ON sx.rowid = statutecontent_fts.rowid
        WHERE
            statutecontent_fts match {{ q }}
        GROUP BY
            sx.pk
    ) {{ select_ids(
        'rowids',
        start_row,
        end_row,
        sort_order
    ) }}
{%- endmacro %}
