{% from 'statutes/_statute_date.sql' import get_statute_date %}
{% from 'statutes/_statute_title.sql' import get_statute_title %}
{% from '_utils/_fts_mark_blurb.sql' import mark_blurb %}
{% from 'statutes/fts/statute_titles/ids.sql' import get_title_ids %}
{% from 'codifications/_json_array_codes.sql' import get_codified_variants %}
WITH rowid_data AS (
    {{ get_title_ids(
        q,
        start_row,
        end_row,
        sort_order
    ) }}
)
SELECT
    (
        SELECT
            max_count
        FROM
            rowid_data
    ) max_row,
    st.statute_id pk,
    ({{ get_statute_date('st.statute_id') }}) row_date,
    (
        {{ get_statute_title(
            'serial',
            'st.statute_id'
        ) }}
    ) title,
    ({{ get_codified_variants('st.statute_id') }}) codes,
    (
        {{ mark_blurb(
            q,
            'st.rowid',
            'statutetitles_fts',
            0
        ) }}
        {# make sure 0 is the proper fts column #}
    ) blurb
FROM
    statutetitles st
WHERE
    st.rowid IN (
        SELECT
            row_idx
        FROM
            rowid_data
    )
ORDER BY
    row_date {{ sort_order }}
