/*

 FTS search Statute a units

 Use SQLite's FTS module to search Statute Content table

 See purpose of limit -1 offset: https://www.mail-archive.com/sqlite-users@mailinglists.sqlite.org/msg115821.html
 */
select json_group_array(material_snippets)
from (
        select json_object(
                "material_path",
                s.mp,
                "extract",
                snippet(
                    StatuteContent_fts,
                    0,
                    '_',
                    '_',
                    '...',
                    64
                )
            ) as material_snippets
        from StatuteContent_fts
            join StatuteContent s on s.rowid = StatuteContent_fts.rowid
        where StatuteContent_fts match :search
            and s.pk = :statute_pk
        limit -1 offset 0
    )
